"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShowWhenAuthenticating = exports.ShowWhenNotAuthenticatedAnResolved = exports.ShowWhenNotAuthenticated = exports.ShowWhenAuthenticated = void 0;
const react_1 = __importStar(require("react"));
const AuthContext_1 = __importDefault(require("./AuthContext"));
const ConfigContext_1 = __importDefault(require("./ConfigContext"));
const orderingCore = __importStar(require("@orderingstack/ordering-core"));
const axios_1 = __importDefault(require("axios"));
const utils_1 = require("./utils");
const jwt_decode_1 = require("jwt-decode");
const ModuleContext_1 = require("./ModuleContext");
// @ts-ignore
require("abortcontroller-polyfill/dist/abortcontroller-polyfill-only");
const mutex_1 = require("./utils/mutex");
const DefaultDeviceCode_1 = require("./components/DefaultDeviceCode");
const mutex = new mutex_1.Mutex(0);
const _refreshStorageHandler = {
    getRefreshToken: (tenant) => {
        return (window.localStorage.getItem(`orderingstack_${tenant}_refreshToken`) || '');
    },
    setRefreshToken: (tenant, token) => {
        window.localStorage.setItem(`orderingstack_${tenant}_refreshToken`, token);
    },
    clearRefreshToken: (tenant) => {
        window.localStorage.removeItem(`orderingstack_${tenant}_refreshToken`);
    },
};
function getModuleConfig(baseUrl, accessToken) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const tokenData = (0, jwt_decode_1.jwtDecode)(accessToken);
            if (tokenData.MODULE) {
                const { data } = yield axios_1.default.get(`${baseUrl}/auth-api/api/module-config`, {
                    headers: {
                        Authorization: `Bearer ${accessToken}`,
                    },
                });
                return data;
            }
        }
        catch (e) {
            console.warn('JWT decode failed', e);
            return undefined;
        }
    });
}
function isSuccess(data) {
    return !(data === null || data === void 0 ? void 0 : data.error) && !!(data === null || data === void 0 ? void 0 : data.refresh_token);
}
function isPendingAuth(data) {
    return (data === null || data === void 0 ? void 0 : data.error) === 'authorization_pending';
}
function isSlowDown(data) {
    return (data === null || data === void 0 ? void 0 : data.error) === 'slow_down';
}
function deviceLoginReducer(state, action) {
    const { type, payload } = action;
    switch (type) {
        case 'enable':
            return Object.assign(Object.assign({}, state), { isDeviceCode: true });
        case 'loading':
            return Object.assign(Object.assign({}, state), { isDeviceCode: true, loading: true });
        case 'setValues':
            return Object.assign(Object.assign({}, state), { data: payload, error: undefined, loading: false });
        case 'error':
            return Object.assign(Object.assign({}, state), { error: payload });
        case 'disable':
            return {
                tenant: state.tenant,
                isDeviceCode: false,
                baseUrl: state.baseUrl,
                user: state.user,
            };
        default:
            return state;
    }
}
function hasValidRoles({ acceptedRolesArray, roles, }) {
    if (!acceptedRolesArray || acceptedRolesArray.length === 0) {
        return true;
    }
    const authorities = roles.map((r) => r.role);
    const rolesIntersection = acceptedRolesArray.filter((value) => authorities.includes(value));
    const isAuthorized = rolesIntersection.length > 0; //authorities.includes(role);
    return isAuthorized;
}
function checkDisallowedRoles({ roles, disallowedRoles, }) {
    if (!disallowedRoles || disallowedRoles.length === 0) {
        return [];
    }
    return roles
        .map((r) => r.role)
        .filter((role) => disallowedRoles.some((regExp) => regExp.test(role)));
}
function AuthWrapper(props) {
    const refreshStorageHandler = props.refreshStorageHandler || _refreshStorageHandler;
    const _configContext = (0, react_1.useContext)(ConfigContext_1.default);
    if (!_configContext) {
        return react_1.default.createElement(react_1.Fragment, null, "Configuration should be provided");
    }
    const config = _configContext;
    const { baseUrl, tenant } = config;
    const api = (0, react_1.useMemo)(() => axios_1.default.create({ baseURL: baseUrl }), [baseUrl]);
    const [auth, setAuth] = (0, react_1.useState)({
        loggedIn: false,
        UUID: '',
        authProvider: () => Promise.resolve({ token: '', UUID: '' }),
        signOut: onSignOut,
    });
    const [moduleConfig, setModuleConfig] = (0, react_1.useState)(undefined);
    const [resolved, setResolved] = (0, react_1.useState)(false);
    const [state, dispatch] = (0, react_1.useReducer)(deviceLoginReducer, {
        isDeviceCode: false,
        tenant: tenant,
        baseUrl: baseUrl,
    });
    const [disallowedRoles, setDisallowedRoles] = (0, react_1.useState)(null);
    function onSignOut() {
        console.log('--- log out ----');
        setAuth({
            loggedIn: false,
            UUID: '',
            authProvider: () => Promise.resolve({ token: '', UUID: '' }),
            signOut: onSignOut,
        });
        setModuleConfig(undefined);
        setResolved(true);
        orderingCore.clearAuthData(config.tenant, refreshStorageHandler);
    }
    function getUserData(baseUrl, authProvider, setAuth) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a;
            let haveToken = false;
            try {
                const { UUID, token } = yield authProvider();
                if (token) {
                    const userData = yield orderingCore.getLoggedUserData(baseUrl, token);
                    if (!hasValidRoles({
                        acceptedRolesArray: props.roles,
                        roles: userData.roles,
                    })) {
                        console.warn('--- USER HAS NO REQUIRED ROLES ----- ');
                        onSignOut();
                        setResolved(true);
                        alert('User has no required roles');
                        return false;
                    }
                    const userDisallowedRoles = checkDisallowedRoles({
                        roles: userData.roles,
                        disallowedRoles: props.disallowedRoles,
                    });
                    if (userDisallowedRoles.length) {
                        console.warn('--- USER HAS DISALLOWED ROLES ----- ', userDisallowedRoles);
                        (_a = props.appInsights) === null || _a === void 0 ? void 0 : _a.trackTrace({
                            message: 'Front user has disallowed roles',
                            severityLevel: 2, // Warning
                            properties: {
                                uuid: UUID,
                                roles: userData.roles,
                                userDisallowedRoles,
                            },
                        });
                        if (props.logoutOnDisallowedRoles) {
                            setDisallowedRoles(userDisallowedRoles);
                            onSignOut();
                            setResolved(true);
                            return false;
                        }
                    }
                    const module = yield getModuleConfig(config.baseUrl, token);
                    if (module) {
                        setModuleConfig(module);
                    }
                    setAuth({
                        loggedIn: true,
                        email: userData.login,
                        UUID: UUID,
                        authProvider: authProvider,
                        signOut: onSignOut,
                    });
                    haveToken = true;
                }
            }
            catch (err) {
                onSignOut();
            }
            setResolved(true);
            return haveToken;
        });
    }
    function deviceCodeLogin(moduleId, abortController) {
        return __awaiter(this, void 0, void 0, function* () {
            dispatch({ type: 'enable' });
            while (!abortController.signal.aborted) {
                try {
                    dispatch({ type: 'loading' });
                    // Get code
                    const { data: resData } = yield api.post('/auth-oauth2/oauth/device', { module: moduleId }, {
                        signal: abortController.signal,
                        headers: {
                            Accept: 'application/json',
                            'X-Tenant': tenant,
                            'Content-Type': 'application/x-www-form-urlencoded',
                            Authorization: `Basic ${config.basicAuth}`,
                        },
                    });
                    const exp = Date.now() + resData.expires_in * 1000;
                    dispatch({ type: 'setValues', payload: Object.assign(Object.assign({}, resData), { exp }) });
                    let success = false;
                    while (!abortController.signal.aborted && Date.now() < exp - 2000) {
                        const { data: tokenData } = yield api.post('/auth-oauth2/oauth/token', {
                            device_code: resData.device_code,
                            grant_type: 'urn:ietf:params:oauth:grant-type:device_code',
                        }, {
                            signal: abortController.signal,
                            headers: {
                                Accept: 'application/json',
                                'X-Tenant': tenant,
                                'Content-Type': 'application/x-www-form-urlencoded',
                                Authorization: `Basic ${config.basicAuth}`,
                            },
                            validateStatus: (status) => status < 500,
                        });
                        if (!isSuccess(tokenData)) {
                            yield new Promise((resolve) => setTimeout(resolve, resData.interval * 1000));
                        }
                        else {
                            yield refreshStorageHandler.setRefreshToken(tenant, tokenData.refresh_token);
                            // @ts-ignore
                            orderingCore.setAuthData(tenant, tokenData, refreshStorageHandler);
                            success = true;
                            break;
                        }
                    }
                    if (success) {
                        break;
                    }
                }
                catch (e) {
                    if (e.name === 'AbortError') {
                        break;
                    }
                    const err = (0, utils_1.getErrorMessage)(e);
                    console.log('err', err);
                    // TODO check if kind is INVALID_MODULE
                    if (err.message) {
                        dispatch({ type: 'error', payload: err });
                    }
                    yield new Promise((resolve) => setTimeout(resolve, 10000));
                    console.warn(e);
                    // continue loop
                }
            }
            dispatch({ type: 'disable' });
        });
    }
    (0, react_1.useEffect)(() => {
        if (auth.loggedIn) {
            return;
        }
        const abortController = new AbortController();
        function init(abortCtrl) {
            return __awaiter(this, void 0, void 0, function* () {
                //console.log("AutWrapper init --- ");
                const authProvider = orderingCore.createAuthDataProvider({
                    BASE_URL: config.baseUrl,
                    TENANT: config.tenant,
                    BASIC_AUTH: config.basicAuth,
                    anonymousAuth: config.anonymousOnInit,
                }, refreshStorageHandler, false, (error) => {
                    setAuth((prev) => (Object.assign(Object.assign({}, prev), { loggedIn: false, UUID: '' })));
                    setResolved(false);
                });
                const params = new URLSearchParams(window.location.search);
                const moduleId = params.get('module') || config.moduleId;
                const refreshToken = params.get('refreshToken') || config.refreshToken;
                const { token } = yield authProvider();
                console.log('moduleId', moduleId, 'token exists?', !!token);
                if (moduleId && !token && !refreshToken) {
                    yield mutex.getLock(() => deviceCodeLogin(moduleId, abortCtrl));
                }
                // Check for refreshToken in search params
                try {
                    if (refreshToken) {
                        refreshStorageHandler.setRefreshToken(config.tenant, refreshToken);
                        // Remove refresh token from search params
                        params.delete('refreshToken');
                        const url = `${window.location.origin}${window.location.pathname}?${params.toString()}`;
                        window.history.replaceState(null, '', url);
                    }
                }
                catch (e) {
                    console.warn(e);
                }
                void getUserData(config.baseUrl, authProvider, setAuth);
                window.addEventListener('message', function (event) {
                    if (event.origin !== config.baseUrl)
                        return;
                    const authData = event.data;
                    // console.log(authData);
                    if (authData.UUID === '') {
                        setAuth({
                            loggedIn: false,
                            UUID: '',
                            authProvider: authProvider,
                            signOut: onSignOut,
                        });
                    }
                    else {
                        orderingCore.setAuthData(config.tenant, {
                            UUID: authData.UUID,
                            access_token: authData.access_token,
                            refresh_token: authData.refresh_token,
                            expires_in: authData.expires_in,
                        }, refreshStorageHandler);
                        setAuth({
                            loggedIn: true,
                            UUID: authData.UUID,
                            authProvider: authProvider,
                            signOut: onSignOut,
                        });
                        getUserData(config.baseUrl, authProvider, setAuth);
                    }
                });
            });
        }
        void init(abortController);
        return () => {
            abortController.abort();
        };
    }, [auth === null || auth === void 0 ? void 0 : auth.loggedIn, config]);
    if (state.isDeviceCode) {
        const DeviceCodeComp = props.DeviceCodeComp || DefaultDeviceCode_1.DefaultDeviceCode;
        return react_1.default.createElement(DeviceCodeComp, Object.assign({}, state));
    }
    if (disallowedRoles === null || disallowedRoles === void 0 ? void 0 : disallowedRoles.length) {
        const DisallowedRolesComp = props.DisallowedRolesComp || DefaultDisallowedRolesComp;
        return react_1.default.createElement(DisallowedRolesComp, null);
    }
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(ModuleContext_1.ModuleContext.Provider, { value: moduleConfig },
            react_1.default.createElement(AuthContext_1.default.Provider, { value: Object.assign(Object.assign({}, auth), { resolved }) }, props.children))));
}
exports.default = AuthWrapper;
function ShowWhenAuthenticated(props) {
    const { loggedIn } = (0, react_1.useContext)(AuthContext_1.default);
    return loggedIn ? react_1.default.createElement(react_1.Fragment, null, props.children) : null;
}
exports.ShowWhenAuthenticated = ShowWhenAuthenticated;
function ShowWhenNotAuthenticated(props) {
    const { loggedIn } = (0, react_1.useContext)(AuthContext_1.default);
    return !loggedIn ? react_1.default.createElement(react_1.Fragment, null, props.children) : null;
}
exports.ShowWhenNotAuthenticated = ShowWhenNotAuthenticated;
function ShowWhenNotAuthenticatedAnResolved(props) {
    const { loggedIn, resolved } = (0, react_1.useContext)(AuthContext_1.default);
    return !loggedIn && resolved ? react_1.default.createElement(react_1.Fragment, null, props.children) : null;
}
exports.ShowWhenNotAuthenticatedAnResolved = ShowWhenNotAuthenticatedAnResolved;
function ShowWhenAuthenticating(props) {
    const { resolved } = (0, react_1.useContext)(AuthContext_1.default);
    return !resolved ? react_1.default.createElement(react_1.Fragment, null, props.children) : null;
}
exports.ShowWhenAuthenticating = ShowWhenAuthenticating;
function DefaultDisallowedRolesComp() {
    return (react_1.default.createElement("div", { style: {
            width: '100%',
            height: '100vh',
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            justifyContent: 'center',
            fontSize: '2vw',
            backgroundColor: 'white',
        } },
        react_1.default.createElement("div", { style: {
                textAlign: 'center',
                display: 'flex',
                flexDirection: 'column',
                alignItems: 'center',
            } },
            react_1.default.createElement("h1", null, "Auth error 101. Contact support"))));
}
