"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const AuthContext_1 = __importDefault(require("./AuthContext"));
const OrdersContext_1 = __importDefault(require("./OrdersContext"));
const ConfigContext_1 = __importDefault(require("./ConfigContext"));
const orderingCore = __importStar(require("@orderingstack/ordering-core"));
function OrderProvider(props) {
    const _configContext = (0, react_1.useContext)(ConfigContext_1.default);
    if (!_configContext) {
        return react_1.default.createElement(react_1.Fragment, null, "Configuration should be provided");
    }
    const config = _configContext;
    const [orders, setOrders] = (0, react_1.useState)({ orderRecMap: {}, loaded: false });
    const { authProvider, loggedIn } = (0, react_1.useContext)(AuthContext_1.default);
    const onOrdersUpdated = (order, allOrders) => {
        //console.log("--------------" + Object.keys(allOrders).length);
        setOrders({
            orderRecMap: Object.assign({}, allOrders),
            loaded: true,
            error: undefined,
        });
    };
    function setOrderChangesListener(authProvider) {
        return __awaiter(this, void 0, void 0, function* () {
            let disconnect = () => {
                return Promise.resolve();
            };
            try {
                const { token } = yield authProvider();
                if (token) {
                    disconnect = yield orderingCore.orderChangesListener(config.baseUrl, config.tenant, config.venue, authProvider, onOrdersUpdated, () => {
                        setOrders({
                            orderRecMap: {},
                            loaded: false,
                            error: new Error('auth failure'),
                        });
                        return Promise.resolve();
                    }, config.enableKDS, props.onWebsocketNotification, props.onSteeringCommand, {
                        appInsights: props.appInsights,
                        debugWs: props.debugWs,
                        onlyCompletedOrdersForUser: props.onlyCompletedOrdersForUser,
                    });
                }
            }
            catch (err) {
                setOrders({ orderRecMap: {}, loaded: false, error: err });
            }
            return disconnect;
        });
    }
    (0, react_1.useEffect)(() => {
        orderingCore.setOrderStoreUpdatedCallback(onOrdersUpdated);
        const promise = setOrderChangesListener(authProvider);
        return () => {
            promise.then((disconnect) => disconnect());
        };
    }, [loggedIn]);
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(OrdersContext_1.default.Provider, { value: orders }, props.children)));
}
exports.default = OrderProvider;
