"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultDeviceCode = void 0;
const react_1 = __importStar(require("react"));
const qrcode_react_1 = require("qrcode.react");
const react_spinners_1 = require("react-spinners");
const logo_ost_webp_1 = __importDefault(require("../assets/img/logo-ost.webp"));
function Loader() {
    return react_1.default.createElement(react_spinners_1.FadeLoader, null);
}
function QRLoader({ size }) {
    const height = Math.min(size / 10, 25);
    const width = Math.min(size / 30, 5);
    const radius = Math.min(height, width) / 2;
    return (react_1.default.createElement("div", { style: {
            width: size,
            height: size,
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
        } },
        react_1.default.createElement(react_spinners_1.FadeLoader, { height: height, width: width, radius: radius })));
}
function DefaultDeviceCode(props) {
    var _a;
    const { error, loading, data } = props;
    const qrCode = data === null || data === void 0 ? void 0 : data.verification_uri_complete;
    const code = data === null || data === void 0 ? void 0 : data.user_code;
    const [seconds, setSeconds] = (0, react_1.useState)(0);
    (0, react_1.useEffect)(() => {
        if (data === null || data === void 0 ? void 0 : data.exp) {
            const timer = setInterval(() => setSeconds(Math.max(Math.round((data.exp - Date.now()) / 1000), 0)), 1000);
            return () => clearInterval(timer);
        }
        else {
            setSeconds(0);
        }
    }, [data]);
    const ref = (0, react_1.useRef)(null);
    const size = (((_a = ref.current) === null || _a === void 0 ? void 0 : _a.offsetWidth) || 300) - 20;
    const isFromLoader = new URLSearchParams(window.location.search).get('loader') === 'true';
    const enablePopup = new URLSearchParams(window.location.search).get('popup') === 'true';
    return (react_1.default.createElement("div", { style: {
            width: '100%',
            height: '100vh',
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            justifyContent: 'center',
            fontSize: '2vw',
            backgroundColor: '#f8ca08',
        } },
        react_1.default.createElement("img", { src: logo_ost_webp_1.default, alt: "logo", style: { width: '25%', maxWidth: '150px', marginTop: '2rem' } }),
        react_1.default.createElement("div", { style: {
                textAlign: 'center',
                display: 'flex',
                flexDirection: 'column',
                alignItems: 'center',
                backgroundColor: 'white',
                padding: '1rem',
                borderRadius: '1rem',
                margin: 'auto',
                boxShadow: '1px 1px 10px 1px lightgrey',
            } },
            react_1.default.createElement("h3", { style: { fontWeight: 'bold', fontSize: 'max(2vw, 2vh)' } }, "Please authorize this device"),
            (isFromLoader || (error === null || error === void 0 ? void 0 : error.kind) === 'INVALID_MODULE') && (react_1.default.createElement("button", { style: {
                    marginBottom: '1rem',
                    padding: '0.5rem',
                    fontSize: 'medium',
                    fontWeight: 'bold',
                    borderRadius: '0.5rem',
                    backgroundColor: '#f8ca08',
                    boxShadow: '1px 1px 10px 1px lightgrey',
                }, onClick: () => window.location.replace('https://module-loader.orderingstack.com/?reset=true') }, "Change module")),
            react_1.default.createElement("div", { style: {
                    width: '100%',
                    height: '1px',
                    display: 'flex',
                    backgroundColor: 'lightgray',
                } }),
            code && (react_1.default.createElement("div", { style: {
                    display: 'flex',
                    flexDirection: 'row',
                    alignItems: 'center',
                    flexWrap: 'wrap',
                } },
                react_1.default.createElement("h4", { style: {
                        fontSize: '1.25rem',
                        marginRight: '0.5rem',
                    } }, "CODE"),
                react_1.default.createElement("span", { style: {
                        textTransform: 'uppercase',
                        fontSize: '2.25rem',
                        fontWeight: 'bold',
                    } }, loading ? 'Loading...' : code))),
            code && (react_1.default.createElement("h4", { style: { fontSize: 'max(1.5vw, 1.5vh)' } },
                "Code validity ",
                seconds,
                "s")),
            qrCode && !loading && (react_1.default.createElement("button", { disabled: !enablePopup, onClick: () => window.open(qrCode, '_blank', 'popup,width=450,height=500'), style: {
                    backgroundColor: 'white',
                    border: 'unset',
                    cursor: 'pointer',
                    borderRadius: 'min(2vw, 2vh)',
                } },
                react_1.default.createElement(qrcode_react_1.QRCodeSVG, { value: qrCode, size: size, level: "H" }))),
            loading && react_1.default.createElement(QRLoader, { size: size }),
            (error === null || error === void 0 ? void 0 : error.message) && (react_1.default.createElement("h1", { style: { color: 'red' } },
                "Error: ",
                error.message)))));
}
exports.DefaultDeviceCode = DefaultDeviceCode;
