import React from 'react';
import * as orderingCore from '@orderingstack/ordering-core';
import { DeviceCodeError } from './utils';
import { ApplicationInsights } from '@microsoft/applicationinsights-web';
import { IDeviceCodeResponse } from './types';
import 'abortcontroller-polyfill/dist/abortcontroller-polyfill-only';
export interface IAuthProps {
    roles?: string[];
    disallowedRoles?: RegExp[];
    logoutOnDisallowedRoles?: boolean;
    appInsights?: ApplicationInsights;
    children: React.ReactNode;
    refreshStorageHandler?: orderingCore.IRefreshTokenStorageHandler;
    DeviceCodeComp?: React.FC<IDeviceLoginState>;
    DisallowedRolesComp?: React.FC<any>;
}
export interface IDeviceLoginState {
    isDeviceCode: boolean;
    data?: IDeviceCodeResponse & {
        exp: number;
    };
    error?: {
        message?: string;
        kind: DeviceCodeError;
    };
    tenant: string;
    baseUrl: string;
    user?: string | null;
    loading?: boolean;
}
export default function AuthWrapper(props: IAuthProps): React.JSX.Element;
export declare function ShowWhenAuthenticated(props: any): React.JSX.Element | null;
export declare function ShowWhenNotAuthenticated(props: any): React.JSX.Element | null;
export declare function ShowWhenNotAuthenticatedAnResolved(props: any): React.JSX.Element | null;
export declare function ShowWhenAuthenticating(props: any): React.JSX.Element | null;
